import path from 'path'
import fs from 'fs-extra'
import { WebStore } from './ts'
import { UseStore, SetStore, GetStore } from 'mobz'
import React, { FC, useRef, useState, useEffect } from "react"
import { Drawer, Select, Input, message, Tooltip, Popconfirm, Tag, Tree as AntdTree, TreeSelect, Button, Space, Table } from "antd";
import { shell } from 'electron'
import PasswordReact from '@alitajs/gesture-password-react';
import useHover from 'react-use-hover'//'react-tooltip'//'rc-tooltip'//'@react-hook/hover'
import ReactJson from 'react-json-view'
import {
  ApiOutlined,
  PlusOutlined,
  ReadOutlined,
  DeleteOutlined,
  ArrowUpOutlined,
  DownloadOutlined,
  FolderOpenOutlined,
  ThunderboltOutlined,
  VerticalAlignTopOutlined,
} from '@ant-design/icons';
//提供免费短信给快递小哥，获取用户资料，各类店铺推广一次一百元...
namespace Ts {
  export type AntdTree = Array<{
    key: number//Tree需要
    value: string | number //TreeSelec
    title: string
    children: AntdTree | []
    id_db: number
    indexJsx_db?: string
    clickArr_db: number[]
    dirPath_db: string
    remark_db: string
    id_parent_db: number
  }>
  export enum selectNow {
    '标题' = '标题',
    '备注' = '备注',
    '改爹' = '改爹',
    '加兄弟' = '加兄弟',
    '加儿子' = '加儿子',
    '亲戚' = '亲戚',
    '账目' = '账目',
    'sku_href' = 'sku_href',
  }
  export type Store = Pick<WebStore, 'send' | 'ml' | 'mlui'>
}
export default class {
  private getstore
  private setstore
  id: number = 0
  rootDir: string[] = ['d://', 'ml',]
  constructor(getstore: GetStore<Ts.Store>, setstore: SetStore<Ts.Store>) {
    this.getstore = getstore
    this.setstore = setstore
    //this.getstore().send.delete({table:'ml',where:{ml:{}}})
    const cc = this.getstore().send.select( { table: 'ml', where: {} })
  }
  sonDirGet = () => {
    try {
      const v = this.getstore().mlui.rootDir
      const c = path.join(...v)
      return (fs.existsSync(c) && fs.readdirSync(c)) || []
    } catch (e) {
      console.log(e)
      return []
    }
  }
  antdTreeGet = (startId: number = 1) => {
    const db = this.getstore().ml
    const id = this.getstore().mlui.id
    const rootDir = path.join(...this.getstore().mlui.rootDir)
    const sonDirArr = this.sonDirGet()
    const c = Object.values(db)
    let defaultExpandedKeys: number[] = []
    const t = (id_parent: number, clickArr: number[]): Ts.AntdTree => {
      const arrobj = c.filter((v) => v.id_parent == id_parent && v.id != v.id_parent)
      return arrobj.length > 0 ?
        arrobj.map(v => {
          const clickArr_db = [...clickArr, v.id]
          if (v.id === id) {
            defaultExpandedKeys = clickArr_db
          }
          const dirPath_db = (sonDirArr.indexOf(id.toString()) > -1) && path.join(rootDir, id.toString()) || ''
          const data = {
            key: v.id,
            value: v.id,
            title: v.name,
            id_db: v.id,
            dirPath_db,
            clickArr_db,
            remark_db: v.remark,
            id_parent_db: v.id_parent,
            children: t(v.id, clickArr_db)
          }
          return data
        }) :
        [];
    }
    const treedb = t(startId, startId === 1 ? [] : [startId])
    return { treedb, defaultExpandedKeys }
  }

  MlIdOpenDir: FC<Ts.AntdTree[0]> = (props) => (
    props.dirPath_db
      ? <Tooltip title='打开目录'>
        <FolderOpenOutlined onClick={() => {
          shell.openExternal(props.dirPath_db).then(shell.beep)
          // cp.exec(`explorer.exe ${props.dirPath_db}`)
        }} />
      </Tooltip>
      : null
  )
  Ml: FC = () => {
    const refObj = useRef(null);
    const [expand, expandSet] = useState<[] | null>(null)
    return (
      <AntdTree
        ref={refObj}
        selectedKeys={[this.getstore().mlui.id]}//选中
        showIcon={false}
        showLine={false}
        draggable={true}
        treeData={this.getstore().mlui.antdTreeGet().treedb}
        // titleRender={(props) => {
        //   const c = props as AntdTree0Props
        //   return stroe.id === c.id_db ?
        //     <MlIdRender1 {...c} /> :
        //     <><MlIdTitle1 {...c} />{c.id_db}</>
        // }}
        expandedKeys={expand || this.getstore().mlui.antdTreeGet().defaultExpandedKeys}
        // defaultExpandedKeys={stroe.antdTreeData.defaultExpandedKeys}
        onDrop={({ dragNode, node }) => {
          const id = dragNode.key as number
          this.getstore().mlui.id = id
          //  stroe.setParent(id, node.key as number)
        }}
        onExpand={(keys, { node, expanded }) => {
          this.getstore().mlui.id = node.key as number
          expandSet(expanded ? null : [])
        }}//折叠
        onSelect={(keys, { node }) => this.getstore().mlui.id = node.key as number}//点击节点
      />
    )
  }
  Mks: FC<Ts.AntdTree[0]> = (props) => {
    return <Button>以后再做</Button>
  }
  MlIdOpenUrl: FC<Ts.AntdTree[0]> = (props) => (
    props.title.indexOf('http') === 0
      ? <Tooltip title='访问网址'>
        <ApiOutlined onClick={() => location.href = props.title} />
      </Tooltip>
      : null
  )
  MlIdTitle1: FC<Ts.AntdTree[0]> = (props) => (
    <Space>
      <Tooltip title={
        <>
          <p>{props.id_db}</p>
          <p>{props.title}</p>
          <p>{props.remark_db}</p>
        </>
      }>
        {props.title.substr(0, 24)}
      </Tooltip>
      <this.MlIdOpenDir {...props} />
      <this.MlIdOpenUrl {...props} />
    </Space>
  )
}


// export const cccccc = {
//   initStore: (self: GetStore<ipc.Param>, set: SetStore<ipc.Param>): ipc.Store => {
//     console.log(__filename + ' initStore success')
//     return {
//       mlStore: {
//         id: 1,
//         idSet: id => self().mlStore.id = id,
//         sonDirGet: () => {
//           try {
//             const v = self().mlStore.mlIdRender1.rootDir
//             const c = path.join(...v)
//             return (fs.existsSync(c) && fs.readdirSync(c)) || []
//           } catch (e) {
//             console.log(e)
//             return []
//           }
//         },
//         antdTreeGet: (startId = 1) => {
//           const db = self().ml
//           const id = self().mlStore.id
//           const rootDir = path.join(...self().mlStore.mlIdRender1.rootDir)
//           const sonDirArr = self().mlStore.sonDirGet()
//           const c = Object.values(db)
//           let defaultExpandedKeys: number[] = []
//           const t = (id_parent: number, clickArr: number[]): ipc.AntdTree => {
//             const arrobj = c.filter((v) => v.id_parent == id_parent && v.id != v.id_parent)
//             return arrobj.length > 0 ?
//               arrobj.map(v => {
//                 const clickArr_db = [...clickArr, v.id]
//                 if (v.id === id) {
//                   defaultExpandedKeys = clickArr_db
//                 }
//                 const dirPath_db = (sonDirArr.indexOf(id.toString()) > -1) && path.join(rootDir, id.toString()) || ''
//                 const data = {
//                   key: v.id,
//                   value: v.id,
//                   title: v.name,
//                   id_db: v.id,
//                   dirPath_db,
//                   clickArr_db,
//                   remark_db: v.remark,
//                   id_parent_db: v.id_parent,
//                   children: t(v.id, clickArr_db)
//                 }
//                 return data
//               }) :
//               [];
//           }
//           const treedb = t(startId, startId === 1 ? [] : [startId])
//           return { treedb, defaultExpandedKeys }
//         },
//         idFromHerfSet: () => self().api('ml_get', {})
//           .then((data) => {
//             const c = Object.values(data.res || []).find(({ name }) => location.href.indexOf(name) > -1)
//             self().mlStore.id = (c && c.id) || 1
//           })
//           .catch(console.error),
//         mlIdRender1: {
//           rootDir: ["d://", "root"],
//           selectDef: ipc.mlIdRender1selectNow.标题,
//           selectNow: ipc.mlIdRender1selectNow.标题,
//           cache: ipc.mlIdRender1selectNow.标题,
//           selectSet: c => {
//             //  cookieSet(self().configBox.state.tsxcookies.mlIdRender1, c.toString())
//             self().mlStore.mlIdRender1.selectNow = c
//           }
//         },
//       }
//     }
//   },
//   initUis: (useStoreRoot: UseStore<ipc.Param>) => {
//     console.log(__filename + ' initUis success')
//     // const Index: FC = () => {
//     //   const store = useStoreRoot((s) => {
//     //     return {
//     //       id: s.mlStore.id,
//     //       apiError: s.ipc.apiError,
//     //       loginEmit: action((c: number[]) => s.socket.loginApi(c.join(''))
//     //         .then(s.mlStore.idFromHerfSet)),
//     //       add: (name: string) => {
//     //         if (location.href.indexOf(name) === -1) {
//     //           return message.error('需包含当前网址哦')
//     //         }
//     //         const f = Object.values(s.ml).find(v => location.href.indexOf(v.name) > -1)
//     //         if (f) {
//     //           message.error('已存在咯')
//     //           return s.mlStore.idSet(f.id)
//     //         }
//     //         return sqlapi('ml_add', { set: { name, id_parent: 1, remark: '' } })
//     //           .then(s.mlStore.idFromHerfSet)
//     //       },
//     //       idFromHerfSet: s.mlStore.idFromHerfSet,
//     //     }
//     //   })
//     //   useEffect(() => { store.idFromHerfSet() }, [])
//     //   return (
//     //     <>
//     //       {
//     //         !store.apiError && <PasswordReact
//     //           width={300}
//     //           height={300}
//     //           onChange={store.loginEmit}
//     //         />
//     //       }
//     //       {
//     //         store.sqlErrorDb &&
//     //         <Button type="text" danger >{store.sqlErrorDb}</Button>
//     //       }
//     //       {
//     //         store.loginbool && store.id === 1 && <NxInput
//     //           defaultValue={location.href}
//     //           width={250}
//     //           icon={'ml.name'}
//     //           onClick={store.add} />
//     //       }
//     //       {
//     //         store.loginbool && <Ml />
//     //       }
//     //     </>
//     //   )
//     // }
//     const Ml: FC = (props) => {
//       const refObj = useRef(null);
//       const stroe = useStoreRoot(s => {
//         const antdTreeData = s.mlStore.antdTreeGet()
//         // console.log({antdTreeData})
//         return {
//           id: s.mlStore.id,
//           idSet: s.mlStore.idSet,
//           // ml: s.ml,
//           antdTreeData,
//           setParent: (id: number, id_parent: number) => s.api('ml_set', { ml: { id }, set: { id, id_parent } }),
//         }
//       })
//       useEffect(() => { stroe.idSet(stroe.id) }, [])
//       const [expand, expandSet] = useState<[] | null>(null)

//       return (
//         <AntdTree
//           ref={refObj}
//           selectedKeys={[stroe.id]}//选中
//           showIcon={false}
//           showLine={false}
//           draggable={true}
//           treeData={stroe.antdTreeData.treedb}
//           titleRender={(props) => {
//             const c = props as AntdTree0Props
//             return stroe.id === c.id_db ?
//               <MlIdRender1 {...c} /> :
//               <><MlIdTitle1 {...c} />{c.id_db}</>
//           }}
//           expandedKeys={expand || stroe.antdTreeData.defaultExpandedKeys}
//           // defaultExpandedKeys={stroe.antdTreeData.defaultExpandedKeys}
//           onDrop={({ dragNode, node }) => {
//             const id = dragNode.key as number
//             stroe.idSet(id)
//             stroe.setParent(id, node.key as number)
//           }}
//           onExpand={(keys, { node, expanded }) => {
//             stroe.idSet(node.key as number)
//             expandSet(expanded ? null : [])
//             console.log(stroe.antdTreeData.defaultExpandedKeys)
//           }}//折叠
//           onSelect={(keys, { node }) => stroe.idSet(node.key as number)}//点击节点
//         />
//       )
//     }
//     const Mms: FC<AntdTree0Props> = (props) => {
//       const stroe = useStoreRoot(s => {
//         const sqlapi = s.api
//         const antdTreeData = s.mlStore.antdTreeGet()
//         return {
//           api: sqlapi,
//           mmdb: Object.values(s.mm).filter(v => v.id_ml === props.id_db).map(v => ({ value: v.idson_ml, label: s.ml[v.idson_ml].name })),
//           antdTreeData,
//         }
//       })
//       useEffect(() => { stroe.api('mm_get', { mm: { id_ml: props.id_db } }) }, [])
//       return (
//         <TreeSelect
//           treeCheckable={true}//搜索框
//           treeCheckStrictly={true}//{value，lable}格式
//           allowClear
//           multiple
//           style={{ width: '100%' }}
//           treeData={stroe.antdTreeData.treedb}
//           defaultValue={stroe.mmdb}
//           value={stroe.mmdb}
//           onChange={(value, labelist, extra) => {
//             const idson_ml = extra.triggerValue as number
//             const id_ml = props.id_db
//             const a = { id_ml, idson_ml }
//             const b = { id_ml: idson_ml, idson_ml: id_ml }
//             if (stroe.mmdb.findIndex(v => v.value === idson_ml) >= 0) {
//               stroe.api('mm_del', { mm: a })
//               stroe.api('mm_del', { mm: b })
//             } else {
//               stroe.api('mm_add', { set: a })
//               stroe.api('mm_add', { set: b })
//             }
//           }}
//         />
//       )
//     }


//     const MlIdRender1: FC<AntdTree0Props> = (props) => {
//       const store = useStoreRoot(s => {
//         const sqlapi = s.api
//         return {
//           selectDef: s.mlStore.mlIdRender1.selectDef,
//           selectNow: s.mlStore.mlIdRender1.selectNow,
//           selectSet: s.mlStore.mlIdRender1.selectSet,
//           del: () => sqlapi('ml_del', { ml: { id: props.id_db } }),
//           addBrother: (name: string) => sqlapi('ml_add', { set: { name, id_parent: props.id_parent_db, remark: '' } }),
//           addSon: (name: string) => sqlapi('ml_add', { set: { name, id_parent: props.id_db, remark: '' } }),
//           parentTop: () => sqlapi('ml_set', { ml: { id: props.id_db }, set: { id_parent: 1 } }),
//           parentSet: (id_parent: number) => sqlapi('ml_set', { ml: { id: props.id_db }, set: { id_parent } }),
//           parentUp: () => {
//             const c = props.clickArr_db;
//             const l = c.length
//             const id_parent = c[l - 3] || 1
//             console.log({ old: c, new: id_parent })
//             return sqlapi('ml_set', { ml: { id: props.id_db }, set: { id_parent } })
//           },
//           nameSet: (name: string) => name == props.title
//             ? message.error('没有修改')
//             : sqlapi('ml_set', { ml: { id: props.id_db }, set: { name } }),
//           remarkGet: () => {
//             try {
//               return JSON.parse(props.remark_db)
//             } catch {
//               return { txt: props.remark_db }
//             }
//           },
//           remarkSet: (remark: string) => sqlapi('ml_set', { ml: { id: props.id_db }, set: { remark } }),
//           antdTreeData: s.mlStore.antdTreeGet()
//         }
//       })
//       const setPaerntShow = useState(true)
//       const css: { [k in typeof store.selectDef]: () => JSX.Element } = {
//         '标题': () => <NxInput onClick={store.nameSet} defaultValue={props.title} icon='标题' />,
//         '备注': () => <ReactJson
//           //   theme="monokai"
//           name={false}
//           src={store.remarkGet()}
//           //  iconStyle='square'
//           // onSelect={(v) => {
//           //   console.log(v)
//           //   v.name === 'login' && eval((v.value as string[]).join(';'))
//           // }}
//           onAdd={({ updated_src }) => store.remarkSet(JSON.stringify(updated_src))}
//           onEdit={({ updated_src }) => store.remarkSet(JSON.stringify(updated_src))}
//           onDelete={({ updated_src }) => store.remarkSet(JSON.stringify(updated_src))}
//         />,
//         '改爹': () => (
//           <Drawer
//             visible={setPaerntShow[0]}
//             //  title={props.title}
//             onClose={() => setPaerntShow[1](!setPaerntShow[0])}
//           >
//             <AntdTree
//               treeData={store.antdTreeData.treedb}
//               showIcon={false}
//               onSelect={(keys, { node }) => store.parentSet(node.key as number)}//点击节点
//             />
//           </Drawer>
//         ),
//         '加兄弟': () => <NxInput onClick={store.addBrother} defaultValue={location.href} icon='兄弟' />,
//         '加儿子': () => <NxInput onClick={store.addSon} defaultValue={location.href} icon='儿子' />,
//         '亲戚': () => <Mms {...props} />,
//         '账目': () => <Mks {...props} />,
//         'sku_href': () => <UrlId {...props} sku_from={location.href} />
//       }
//       return (
//         <>
//           {store.selectDef !== store.selectNow && <MlIdTitle1 {...props} />}
//           <Space>
//             <Tooltip title='删除'><Popconfirm title="删除?" onConfirm={store.del} ><DeleteOutlined /></Popconfirm></Tooltip>
//             <Tooltip title='置顶'><VerticalAlignTopOutlined onClick={store.parentTop} /></Tooltip>
//             <Tooltip title='升级'><ArrowUpOutlined onClick={store.parentUp} /></Tooltip>
//             <MlIdOpenDir {...props} />
//             <MlIdOpenUrl {...props} />
//             <Tooltip title='sku'><ReadOutlined /></Tooltip>
//             {store.remarkGet()['login'] && <Tooltip title='登录'><ThunderboltOutlined onClick={() => eval((store.remarkGet()['login']).join(';'))} /></Tooltip>}
//             <Select bordered={false} style={{ width: 90 }} defaultValue={store.selectNow} onSelect={(v) => store.selectSet(v)}>
//               {Object.keys(css).filter(v => v === 'sku_href' && location.href.indexOf(props.title) === -1 ? false : true)
//                 .map((k) => <Select.Option key={k} value={k} >{k}</Select.Option>)}
//             </Select>
//           </Space>
//           {css[store.selectNow]()}
//         </>
//       )
//     }
//     const UrlId: FC<AntdTree0Props & { sku_from: string }> = ({ sku_from, ...props }) => {
//       const [strOn, strSet] = useState('')
//       const store = useStoreRoot(s => {
//         const sqlapi = s.api
//         const db = Object.values(s.url).find((u) => u.sku_from === sku_from)
//         return {
//           db,
//           get: () => sqlapi('url_get', { url: { sku_from } }),
//           set: (sku_name: string) => db && sqlapi('url_set', { url: { id: db.id }, set: { sku_name } }),
//           del: () => db && sqlapi('url_del', { url: { id: db.id } }),
//           add: () => db && sqlapi('url_add', { set: { idg_ml: props.id_db, sku_from, sku_name: strOn } })
//         }
//       })
//       useEffect(() => { store.get() }, [])
//       return (
//         store.db
//           ? <>
//             <Tooltip title={sku_from}>{sku_from.substr(0, 24)}...</Tooltip>
//             {
//               store.db ?
//                 <>
//                   <NxInput
//                     defaultValue={store.db.sku_name}
//                     onPressEnter={(sku_name) => store.set(sku_name || '')}
//                     icon={<DeleteOutlined />}
//                     onClick={store.del} />
//                   <Uws id_url={store.db.id} />
//                 </>
//                 :
//                 <SearchOn
//                   db={strOn}
//                   icon={<DownloadOutlined />}
//                   dbSet={strSet}
//                   onClick={store.add} />
//             }
//           </>
//           : null
//       )
//     }
    // const Uws: FC<{ id_url: number }> = ({ id_url }) => {
    //   const store = useStoreRoot(s => {
    //     const sqlapi = s.api
    //     return {
    //       db: Object.values(s.uw)
    //         .filter(v => v.id_url === id_url)
    //         .map(({ id, id_word }) => {
    //           const c = {
    //             id,
    //             v: s.word[id_word].v
    //           }
    //           return <Tag closable key={c.id} onClose={() => sqlapi('uw_del', { uw: { id } })}>{c.v}</Tag>
    //         }),
    //       add: async (v_word: string) => {
    //         if (!v_word) {
    //           return
    //         }
    //         if (Object.values(s.uw).findIndex((v) => v.id_url === id_url && v_word === s.word[v.id_word].v) > -1) {
    //           return;
    //         }
    //         const { res } = await sqlapi('word_add', { set: { k: '', v: v_word } })
    //         return sqlapi('uw_add', { set: { id_word: res[0].id, id_url } })
    //       },
    //       // del: (id: number) => sqlapi('uw_del', { uw: { id } }),
    //       get: async () => {
    //         const c = { url: { id: id_url } }
    //         await sqlapi('word_get', c)
    //         return await sqlapi('uw_get', c)
    //       }
    //     }
    //   })
    //   const [iptStr, iptSet] = useState('')
    //   const [isHovering, hoverProps] = useHover();
    //   useEffect(() => { store.get() }, [])
    //   return (
    //     <Space style={{ marginRight: 8 }}>
    //       {
    //         store.db
    //       }
    //       <div {...hoverProps}>
    //         {isHovering ?
    //           (iptStr ?
    //             <NxInput
    //               defaultValue={iptStr}
    //               width={120}
    //               icon={'字词'}
    //               onClick={store.add}
    //             /> :
    //             <Input
    //               size="small"
    //               placeholder={'关键字、词'}
    //               style={{ width: '80' }}
    //               onChange={(e) => iptSet(e.currentTarget.value)}
    //               value={iptStr} />) :
    //           <Tag icon={<PlusOutlined />} />
    //         }
    //       </div>
    //     </Space>
    //   )
    // }
//     //  return { Index }
//   }
// }



