import * as Sql from '0.edsql.mysql/ts'
import { FC } from 'react'
import mlui from './ml'
export type Tables = {
    ml: {
        field: {
            id: number
            id_parent: number
            name: string
            remark: string
            uptimestamp: string,
        },
        join: 'mm'
    }
    mm: {
        field: {
            id: number,
            id_ml: number,
            idson_ml: number
            uptimestamp: string
        }
        join: 'ml'
    }
    mk: {
        field: {
            id: number,
            id_ml: number,
            id_sorder: number
            id_fromdate: string
            remark: string
            price: string
            uptimestamp?: string
        },
        join: never
    }
    url: {
        field: {
            id: number
            idg_ml: number
            sku_from: string
            sku_name: string
            id_group?: number
            sku_price?: number
            uptimestamp: string
        },
        join: never
    }
    word: {
        field: {
            id: number
            k: string
            v: string
            mime?: string
            uptimestamp: string
        },
        join: never
    }
    tag: {
        field: {
            id: number
            id_uw: number
            idclass_ml: string
            uptimestamp: string
        },
        join: never
    }
}
export const JOINS = {
    ml: [],
    mm: ['join ml on ml.id=mm.id_ml'],
    mk: ['join ml on ml.id=mk.id_ml'],
    url: ['join ml on ml.id=url.idg_ml'],
    word: [
        'join uw on uw.id_word=word.id',
        'join url on url.id=uw.id_url',
    ],
    tag: [
        'join url on url.id=uw.id_url',
        'join ml on ml.id=url.idg_ml',
        'join word on word.id=uw.id_word',
    ],
}
export type errorui = {
    [api in Sql.errorName]: FC<Sql.errorBase[api]['res']>
}
export type On = Sql.poolBase[Sql.poolName] | Sql.curdBase<Tables, keyof Tables>[Sql.curdName] | Sql.errorBase[Sql.errorName]
export type WebStore = {
    send: Sql.poolFun & Sql.curdFun<Tables>
    tables: { [T in keyof Tables]: Record<number, Tables[T]['field']> }
  //  pool: { [api in keyof Sql.poolBase]?: Sql.poolBase[api]['res'] }
    error: { [api in keyof Sql.errorBase]?: Sql.errorBase[api]['res'] }
    errorui: errorui
    mlui: mlui
}
